"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/builtin/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = computeIndex;

var _react = _interopRequireDefault(require("react"));

var _constant = _interopRequireDefault(require("./constant"));

function computeIndex(params) {
  var children = params.children,
      startIndex = params.startIndex,
      startX = params.startX,
      pageX = params.pageX,
      viewLength = params.viewLength,
      resistance = params.resistance,
      viewHeights = params.viewHeights;
  var indexMax = _react.default.Children.count(children) - 1;
  var index;

  if (Number.isInteger(startIndex)) {
    if (startX - pageX > 0) {
      //next page
      index = startIndex + (startX - pageX) * 1.0 / viewHeights[startIndex];
    } else {
      //prev page
      index = startIndex + (startX - pageX) / viewHeights[startIndex];
    }
  } else {
    index = startIndex + (startX - pageX) / viewHeights[Math.floor(startIndex)];
  }

  var newStartX;

  if (!resistance) {
    // Reset the starting point
    if (index < 0) {
      index = 0;
      newStartX = (index - startIndex) * viewLength + pageX;
    } else if (index > indexMax) {
      index = indexMax;
      newStartX = (index - startIndex) * viewLength + pageX;
    }
  } else if (index < 0) {
    index = Math.exp(index * _constant.default.RESISTANCE_COEF) - 1;
  } else if (index > indexMax) {
    index = indexMax + 1 - Math.exp((indexMax - index) * _constant.default.RESISTANCE_COEF);
  }

  return {
    index: index,
    startX: newStartX
  };
}